ompi/attribute/attribute.h File Reference.TH "ompi/attribute/attribute.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/attribute/attribute.h \- Implementation for taking care of the attribute that can hang off a comm, win or datatype. 
.SH SYNOPSIS
.br
.PP
\fC#include <string.h>\fP
.br
\fC#include 'mpi.h'\fP
.br
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'ompi/include/constants.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br
\fC#include 'class/ompi_bitmap.h'\fP
.br
\fC#include 'class/opal_hash_table.h'\fP
.br
\fC#include 'mca/gpr/gpr_types.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBATTR_HASH_SIZE\fP   10"
.br
.ti -1c
.RI "#define \fBOMPI_KEYVAL_PREDEFINED\fP   0x0001"
.br
.ti -1c
.RI "#define \fBOMPI_KEYVAL_F77\fP   0x0002"
.br
.ti -1c
.RI "#define \fBOMPI_KEYVAL_F77_MPI1\fP   0x0004"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef enum \fBompi_attribute_type_t\fP \fBompi_attribute_type_t\fP"
.br
.ti -1c
.RI "typedef void() \fBompi_mpi1_fortran_copy_attr_function\fP (MPI_Fint *oldobj, MPI_Fint *keyval, MPI_Fint *extra_state, MPI_Fint *attr_in, MPI_Fint *attr_out, ompi_fortran_logical_t *flag, MPI_Fint *ierr)"
.br
.ti -1c
.RI "typedef void() \fBompi_mpi1_fortran_delete_attr_function\fP (MPI_Fint *obj, MPI_Fint *keyval, MPI_Fint *attr_in, MPI_Fint *extra_state, MPI_Fint *ierr)"
.br
.ti -1c
.RI "typedef void() \fBompi_mpi2_fortran_copy_attr_function\fP (MPI_Fint *oldobj, MPI_Fint *keyval, void *extra_state, void *attr_in, void *attr_out, ompi_fortran_logical_t *flag, MPI_Fint *ierr)"
.br
.ti -1c
.RI "typedef void() \fBompi_mpi2_fortran_delete_attr_function\fP (MPI_Fint *obj, MPI_Fint *keyval, void *attr_in, void *extra_state, MPI_Fint *ierr)"
.br
.ti -1c
.RI "typedef ompi_attribute_fn_ptr_union_t \fBompi_attribute_fn_ptr_union_t\fP"
.br
.ti -1c
.RI "typedef \fBompi_attribute_fortran_ptr_t\fP \fBompi_attribute_fortran_ptr_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef ompi_attrkey_item_t \fBompi_attrkey_item_t\fP"
.br
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum \fBompi_attribute_type_t\fP { \fBCOMM_ATTR\fP =  1, \fBTYPE_ATTR\fP }"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "static int \fBompi_attr_hash_init\fP (opal_hash_table_t **keyhash)"
.br
.RI "\fIConvenient way to initialize the attribute hash table per MPI-Object. \fP"
.ti -1c
.RI "int \fBompi_attr_init\fP (void)"
.br
.RI "\fIInitialize the main attribute hash that stores the key and meta data. \fP"
.ti -1c
.RI "int \fBompi_attr_finalize\fP (void)"
.br
.RI "\fIDestroy the main attribute hash that stores the key and meta data. \fP"
.ti -1c
.RI "int \fBompi_attr_create_keyval\fP (\fBompi_attribute_type_t\fP type, ompi_attribute_fn_ptr_union_t copy_attr_fn, ompi_attribute_fn_ptr_union_t delete_attr_fn, int *key, void *extra_state, int flags)"
.br
.RI "\fICreate a new key for use by attribute of Comm/Win/Datatype. \fP"
.ti -1c
.RI "int \fBompi_attr_free_keyval\fP (\fBompi_attribute_type_t\fP type, int *key, bool predefined)"
.br
.RI "\fIFree an attribute keyval. \fP"
.ti -1c
.RI "int \fBompi_attr_set_c\fP (\fBompi_attribute_type_t\fP type, void *object, opal_hash_table_t **keyhash, int key, void *attribute, bool predefined, bool need_lock)"
.br
.RI "\fISet an attribute on the comm/win/datatype in a form valid for C. \fP"
.ti -1c
.RI "int \fBompi_attr_set_fortran_mpi1\fP (\fBompi_attribute_type_t\fP type, void *object, opal_hash_table_t **keyhash, int key, MPI_Fint attribute, bool predefined, bool need_lock)"
.br
.RI "\fISet an attribute on the comm/win/datatype in a form valid for Fortran MPI-1. \fP"
.ti -1c
.RI "int \fBompi_attr_set_fortran_mpi2\fP (\fBompi_attribute_type_t\fP type, void *object, opal_hash_table_t **keyhash, int key, MPI_Aint attribute, bool predefined, bool need_lock)"
.br
.RI "\fISet an attribute on the comm/win/datatype in a form valid for Fortran MPI-2. \fP"
.ti -1c
.RI "int \fBompi_attr_get_c\fP (opal_hash_table_t *keyhash, int key, void **attribute, int *flag)"
.br
.RI "\fIGet an attribute on the comm/win/datatype in a form valid for C. \fP"
.ti -1c
.RI "int \fBompi_attr_get_fortran_mpi1\fP (opal_hash_table_t *keyhash, int key, MPI_Fint *attribute, int *flag)"
.br
.RI "\fIGet an attribute on the comm/win/datatype in a form valid for Fortran MPI-1. \fP"
.ti -1c
.RI "int \fBompi_attr_get_fortran_mpi2\fP (opal_hash_table_t *keyhash, int key, MPI_Aint *attribute, int *flag)"
.br
.RI "\fIGet an attribute on the comm/win/datatype in a form valid for Fortran MPI-2. \fP"
.ti -1c
.RI "int \fBompi_attr_delete\fP (\fBompi_attribute_type_t\fP type, void *object, opal_hash_table_t *keyhash, int key, bool predefined, bool need_lock)"
.br
.RI "\fIDelete an attribute on the comm/win/datatype. \fP"
.ti -1c
.RI "int \fBompi_attr_copy_all\fP (\fBompi_attribute_type_t\fP type, void *old_object, void *new_object, opal_hash_table_t *oldkeyhash, opal_hash_table_t *newkeyhash)"
.br
.RI "\fIThis to be used from functions like MPI_*_DUP inorder to copy all the attributes from the old Comm/Win/Dtype object to a new object. \fP"
.ti -1c
.RI "int \fBompi_attr_delete_all\fP (\fBompi_attribute_type_t\fP type, void *object, opal_hash_table_t *keyhash)"
.br
.RI "\fIThis to be used to delete all the attributes from the Comm/Win/Dtype object in one shot. \fP"
.ti -1c
.RI "int \fBompi_attr_create_predefined\fP (void)"
.br
.ti -1c
.RI "void \fBompi_attr_create_predefined_callback\fP (\fBorte_gpr_notify_data_t\fP *data, void *cbdata)"
.br
.in -1c
.SH "Detailed Description"
.PP 
Implementation for taking care of the attribute that can hang off a comm, win or datatype. 


.SH "Enumeration Type Documentation"
.PP 
.SS "enum \fBompi_attribute_type_t\fP"
.PP
\fBEnumeration values: \fP
.in +1c
.TP
\fB\fICOMM_ATTR \fP\fP
The attribute belongs to a comm object. 
.PP
Starts with 1 so that we can have it initialized to 0 using memset in the constructor 
.TP
\fB\fITYPE_ATTR \fP\fP
The attribute belongs to datatype object. 
.SH "Function Documentation"
.PP 
.SS "int ompi_attr_copy_all (\fBompi_attribute_type_t\fP type, void * old_object, void * new_object, opal_hash_table_t * oldkeyhash, opal_hash_table_t * newkeyhash)"
.PP
This to be used from functions like MPI_*_DUP inorder to copy all the attributes from the old Comm/Win/Dtype object to a new object. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIold_object\fP The old COMM/WIN/DTYPE object (IN) 
.br
\fInew_object\fP The new COMM/WIN/DTYPE object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on old object(IN) 
.br
\fInewkeyhash\fP The attribute hash table hanging on new object(IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code 
.RE
.PP

.SS "int ompi_attr_create_keyval (\fBompi_attribute_type_t\fP type, ompi_attribute_fn_ptr_union_t copy_attr_fn, ompi_attribute_fn_ptr_union_t delete_attr_fn, int * key, void * extra_state, int flags)"
.PP
Create a new key for use by attribute of Comm/Win/Datatype. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIcopy_attr_fn\fP Union variable containing the function pointer to be used in order to copy the attribute (IN) 
.br
\fIdelete_attr_fn\fP Function pointer to be used for deleting the attribute (IN) 
.br
\fIkey\fP The newly created key is returned here (OUT) 
.br
\fIextra_state\fP Extra state to hang off/do some special things (IN) 
.br
\fIflags\fP Flags for the key -- flags contain OMPI_KEYVAL_F77, OMPI_KEYVAL_PREDEFINED NOTE: I have taken the assumption that user cannot modify/delete any predefined keys or the attributes attached. To accomplish this, all MPI* calls will have OMPI_KEYVAL_PREDEFINED set as 0. MPI implementors who will need to play with the predefined keys and attributes would call the ompi* functions here and not the MPI* functions, with OMPI_KEYVAL_PREDEFINED set to 1. END OF NOTE
.RE
.PP
NOTE: For the function pointers, you need to create a variable of the union type 'ompi_attribute_fn_ptr_union_t' and assign the proper field. to be passed into this function END OF NOTE
.PP
\fBReturns:\fP
.RS 4
OMPI return code 
.RE
.PP

.SS "int ompi_attr_delete (\fBompi_attribute_type_t\fP type, void * object, opal_hash_table_t * keyhash, int key, bool predefined, bool need_lock)"
.PP
Delete an attribute on the comm/win/datatype. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIobject\fP The actual Comm/Win/Datatype object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on the object(IN) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIpredefined\fP Whether the key is predefined or not 0/1 (IN) 
.br
\fIneed_lock\fP Whether we need to need to lock the keyval_lock or not 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
Note that need_lock should *always* be true when this function is invoked from an top-level MPI function. It is only false when this function is invoked internally (i.e., when we already hold the relevant locks, and we don't want to try to lock them again, recursively). 
.SS "int ompi_attr_delete_all (\fBompi_attribute_type_t\fP type, void * object, opal_hash_table_t * keyhash)"
.PP
This to be used to delete all the attributes from the Comm/Win/Dtype object in one shot. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIobject\fP The COMM/WIN/DTYPE object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on the object(IN) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code 
.RE
.PP

.SS "int ompi_attr_free_keyval (\fBompi_attribute_type_t\fP type, int * key, bool predefined)"
.PP
Free an attribute keyval. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIkey\fP key, which is set to MPI_KEY_INVALID (IN/OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code 
.RE
.PP

.SS "int ompi_attr_get_c (opal_hash_table_t * keyhash, int key, void ** attribute, int * flag)"
.PP
Get an attribute on the comm/win/datatype in a form valid for C. 
.PP
\fBParameters:\fP
.RS 4
\fIkeyhash\fP The attribute hash table hanging on the object(IN) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (OUT) 
.br
\fIflag\fP Flag whether an attribute is associated with the key (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
All three of these functions (\fBompi_attr_get_c()\fP, \fBompi_attr_get_fortran_mpi1()\fP, and \fBompi_attr_get_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SS "int ompi_attr_get_fortran_mpi1 (opal_hash_table_t * keyhash, int key, MPI_Fint * attribute, int * flag)"
.PP
Get an attribute on the comm/win/datatype in a form valid for Fortran MPI-1. 
.PP
\fBParameters:\fP
.RS 4
\fIkeyhash\fP The attribute hash table hanging on the object(IN) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (OUT) 
.br
\fIflag\fP Flag whether an attribute is associated with the key (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
All three of these functions (\fBompi_attr_get_c()\fP, \fBompi_attr_get_fortran_mpi1()\fP, and \fBompi_attr_get_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SS "int ompi_attr_get_fortran_mpi2 (opal_hash_table_t * keyhash, int key, MPI_Aint * attribute, int * flag)"
.PP
Get an attribute on the comm/win/datatype in a form valid for Fortran MPI-2. 
.PP
\fBParameters:\fP
.RS 4
\fIkeyhash\fP The attribute hash table hanging on the object(IN) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (OUT) 
.br
\fIflag\fP Flag whether an attribute is associated with the key (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
All three of these functions (\fBompi_attr_get_c()\fP, \fBompi_attr_get_fortran_mpi1()\fP, and \fBompi_attr_get_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SS "int ompi_attr_init (void)"
.PP
Initialize the main attribute hash that stores the key and meta data. 
.PP
\fBReturns:\fP
.RS 4
OMPI return code 
.RE
.PP

.SS "int ompi_attr_set_c (\fBompi_attribute_type_t\fP type, void * object, opal_hash_table_t ** keyhash, int key, void * attribute, bool predefined, bool need_lock)"
.PP
Set an attribute on the comm/win/datatype in a form valid for C. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIobject\fP The actual Comm/Win/Datatype object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on the object(IN/OUT) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (IN) 
.br
\fIpredefined\fP Whether the key is predefined or not 0/1 (IN) 
.br
\fIneed_lock\fP Whether we need to need to lock the keyval_lock or not 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
If (*keyhash) == NULL, a new keyhash will be created and initialized.
.PP
Note that need_lock should *always* be true when this function is invoked from an top-level MPI function. It is only false when this function is invoked internally (i.e., when we already hold the relevant locks, and we don't want to try to lock them again, recursively).
.PP
All three of these functions (\fBompi_attr_set_c()\fP, \fBompi_attr_set_fortran_mpi1()\fP, and \fBompi_attr_set_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SS "int ompi_attr_set_fortran_mpi1 (\fBompi_attribute_type_t\fP type, void * object, opal_hash_table_t ** keyhash, int key, MPI_Fint attribute, bool predefined, bool need_lock)"
.PP
Set an attribute on the comm/win/datatype in a form valid for Fortran MPI-1. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIobject\fP The actual Comm/Win/Datatype object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on the object(IN/OUT) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (IN) 
.br
\fIpredefined\fP Whether the key is predefined or not 0/1 (IN) 
.br
\fIneed_lock\fP Whether we need to need to lock the keyval_lock or not 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
If (*keyhash) == NULL, a new keyhash will be created and initialized.
.PP
Note that need_lock should *always* be true when this function is invoked from an top-level MPI function. It is only false when this function is invoked internally (i.e., when we already hold the relevant locks, and we don't want to try to lock them again, recursively).
.PP
All three of these functions (\fBompi_attr_set_c()\fP, \fBompi_attr_set_fortran_mpi1()\fP, and \fBompi_attr_set_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SS "int ompi_attr_set_fortran_mpi2 (\fBompi_attribute_type_t\fP type, void * object, opal_hash_table_t ** keyhash, int key, MPI_Aint attribute, bool predefined, bool need_lock)"
.PP
Set an attribute on the comm/win/datatype in a form valid for Fortran MPI-2. 
.PP
\fBParameters:\fP
.RS 4
\fItype\fP Type of attribute (COMM/WIN/DTYPE) (IN) 
.br
\fIobject\fP The actual Comm/Win/Datatype object (IN) 
.br
\fIkeyhash\fP The attribute hash table hanging on the object(IN/OUT) 
.br
\fIkey\fP Key val for the attribute (IN) 
.br
\fIattribute\fP The actual attribute pointer (IN) 
.br
\fIpredefined\fP Whether the key is predefined or not 0/1 (IN) 
.br
\fIneed_lock\fP Whether we need to need to lock the keyval_lock or not 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
If (*keyhash) == NULL, a new keyhash will be created and initialized.
.PP
Note that need_lock should *always* be true when this function is invoked from an top-level MPI function. It is only false when this function is invoked internally (i.e., when we already hold the relevant locks, and we don't want to try to lock them again, recursively).
.PP
All three of these functions (\fBompi_attr_set_c()\fP, \fBompi_attr_set_fortran_mpi1()\fP, and \fBompi_attr_set_fortran_mpi2()\fP) could have been combined into one function that took some kind of (void*) and an enum to indicate which way to translate the final representation, but that just seemed to make an already complicated situation more complicated through yet another layer of indirection.
.PP
So yes, this is more code, but it's clearer and less error-prone (read: better) this way. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
